Index: trunk/src/VBox/Installer/darwin/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/darwin/Makefile.kmk	(revision 43238)
+++ trunk/src/VBox/Installer/darwin/Makefile.kmk	(revision 43239)
@@ -117,5 +117,5 @@
 #
 $(VBOX_PATH_DIST)/VirtualBox-$(VBOX_VERSION_MAJOR).$(VBOX_VERSION_MINOR).$(VBOX_VERSION_BUILD)-r$(VBOX_SVN_REV).dmg: \
-		$(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.mpkg \
+		$(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.pkg \
 		$(VBOX_BRAND_DARWIN_DISKIMAGE_BG) \
 		$(VBOX_BRAND_DARWIN_DISKIMAGE_DS_STORE) \
@@ -129,5 +129,5 @@
 	sudo rm -Rf $(VBOX_PATH_PACK_TMP)/DiskImage.tmp
 	$(MKDIR) -p $(VBOX_PATH_PACK_TMP)/DiskImage.tmp/
-	sudo mv $(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.mpkg $(VBOX_PATH_PACK_TMP)/DiskImage.tmp/
+	sudo mv $(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.pkg $(VBOX_PATH_PACK_TMP)/DiskImage.tmp/
 	sudo rm -Rf \
 		$@ \
@@ -165,5 +165,5 @@
 # The meta-package.
 #
-$(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.mpkg: \
+$(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.pkg: \
 		$(VBOX_PATH_PACK_TMP)/Packages/VBoxStartupItems.pkg \
 		$(VBOX_PATH_PACK_TMP)/Packages/VBoxKEXTs.pkg \
@@ -178,13 +178,13 @@
 	sudo rm -Rf \
 		$@ \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.root \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.desc \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.root \
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.desc \
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res
 	@# Correct directory permissions are important.
 	$(MKDIR) -p \
 		$(@D) \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.desc \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/English.lproj
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.desc \
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res \
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/English.lproj
 	@# Do keyword replacement in the package info and description files.
 	$(SED) \
@@ -196,18 +196,18 @@
 		-e 's/@VBOX_PRODUCT@/$(VBOX_PRODUCT)/g' \
 		-e 's/@VBOX_C_YEAR@/$(VBOX_C_YEAR)/g' \
-		--output $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/English.lproj/Welcome.rtf \
+		--output $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/English.lproj/Welcome.rtf \
 		$(VBOX_PATH_DI_SRC)/VirtualBox_mpkg/Welcome.rtf
 	@# Copy the resources.
-	$(INSTALL) -m 0644 $(VBOX_PATH_DI_SRC)/VirtualBox_mpkg/Conclusion.rtf                   $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/English.lproj/Conclusion.rtf
+	$(INSTALL) -m 0644 $(VBOX_PATH_DI_SRC)/VirtualBox_mpkg/Conclusion.rtf                   $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/English.lproj/Conclusion.rtf
 	$(SED) \
 		-e 's/@VBOX_VENDOR@/$(VBOX_VENDOR)/g' \
 		-e 's/@VBOX_PRODUCT@/$(VBOX_PRODUCT)/g' \
 		-e 's/@VBOX_C_YEAR@/$(VBOX_C_YEAR)/g' \
-		--output $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/English.lproj/Localizable.strings \
+		--output $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/English.lproj/Localizable.strings \
 		$(VBOX_PATH_DI_SRC)/VirtualBox_mpkg/Localizable.strings
-	$(INSTALL) -m 0644 $(VBOX_BRAND_DARWIN_INSTALLER_BG)                                    $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/background.tif
+	$(INSTALL) -m 0644 $(VBOX_BRAND_DARWIN_INSTALLER_BG)                                    $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/background.tif
 	$(foreach f,$(VBOX_INSTALLER_ADD_LANGUAGES), \
 		$(MKDIR) -p \
-			$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj$(NLTAB) \
+			$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj$(NLTAB) \
 		$(SED) \
 			-e 's/@VBOX_VERSION_STRING@/$(VBOX_VERSION_STRING)/g' \
@@ -215,12 +215,12 @@
 			-e 's/@VBOX_VERSION_MINOR@/$(VBOX_VERSION_MINOR)/g' \
 			-e 's/@VBOX_VERSION_BUILD@/$(VBOX_VERSION_BUILD)/g' \
-			--output $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj/Welcome.rtf \
+			--output $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj/Welcome.rtf \
 			$(VBOX_BRAND_$(f)_VIRTUALBOX_WELCOME_RTF)$(NLTAB) \
-		$(INSTALL) -m 0644 $(VBOX_BRAND_$(f)_VIRTUALBOX_CONCLUSION_RTF)                $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj/Conclusion.rtf$(NLTAB) \
+		$(INSTALL) -m 0644 $(VBOX_BRAND_$(f)_VIRTUALBOX_CONCLUSION_RTF)                $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj/Conclusion.rtf$(NLTAB) \
 		$(SED) \
 			-e 's/@VBOX_VENDOR@/$(VBOX_VENDOR)/g' \
 			-e 's/@VBOX_PRODUCT@/$(VBOX_PRODUCT)/g' \
 			-e 's/@VBOX_C_YEAR@/$(VBOX_C_YEAR)/g' \
-			--output $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj/Localizable.strings \
+			--output $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res/$(VBOX_INSTALLER_$(f)_DARWIN_TARGET).lproj/Localizable.strings \
 			$(VBOX_BRAND_$(f)_VIRTUALBOX_LOCALIZABLE_STRINGS)$(NLTAB) \
 	)
@@ -229,6 +229,6 @@
 		--distribution $(VBOX_PATH_DI_SRC)/VirtualBox_mpkg/distribution.dist \
 		--package-path $(VBOX_PATH_PACK_TMP)/Packages \
-		--resources $(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res \
-		--identifier org.virtualbox.mpkg.virtualbox \
+		--resources $(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res \
+		--identifier org.VirtualBox.mpkg.virtualbox \
 		--version $(VBOX_VERSION_MAJOR).$(VBOX_VERSION_MINOR).$(VBOX_VERSION_BUILD) \
 		$(if $(VBOX_MACOSX_INSTALLER_SIGN),--sign "$(VBOX_MACOSX_INSTALLER_SIGN)",) \
@@ -236,9 +236,9 @@
 	@# Cleanup.
 	sudo rm -Rf \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.root \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.desc \
-		$(VBOX_PATH_PACK_TMP)/VirtualBox.mpkg.res
-
-VirtualBox.mpkg: $(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.mpkg
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.root \
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.desc \
+		$(VBOX_PATH_PACK_TMP)/VirtualBox.dist.res
+
+VirtualBox.pkg:: $(VBOX_PATH_PACK_TMP)/DiskImage/VirtualBox.pkg
 
 #