Index: trunk/src/VBox/Additions/x11/vboxmouse/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/x11/vboxmouse/Makefile.kmk	(revision 43274)
+++ trunk/src/VBox/Additions/x11/vboxmouse/Makefile.kmk	(revision 43275)
@@ -99,5 +99,4 @@
 vboxmouse_drv_13_DEFS := $(vboxmouse_drv_70_DEFS) NO_ANSIC
 vboxmouse_drv_13_INCS := \
-	$(VBOX_PATH_X11_XORG_1_3) \
 	$(VBOX_PATH_X11_ROOT)/inputproto-1.4.4 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.3.0.0 \
@@ -114,6 +113,7 @@
 vboxmouse_drv_14_DEFS := $(vboxmouse_drv_70_DEFS) NO_ANSIC
 vboxmouse_drv_14_INCS := \
-	$(VBOX_PATH_X11_XORG_1_4) \
-	$(VBOX_PATH_X11_XORG_1_4)/xorg \
+	$(VBOX_PATH_X11_ROOT)/inputproto-1.4.4 \
+	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.4.2 \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_14_SOURCES = \
@@ -128,6 +128,6 @@
 vboxmouse_drv_15_DEFS := $(vboxmouse_drv_70_DEFS) NO_ANSIC
 vboxmouse_drv_15_INCS := \
-	$(VBOX_PATH_X11_XORG_1_5) \
 	$(VBOX_PATH_X11_ROOT)/inputproto-1.4.4 \
+	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.5.3 \
 	$(PATH_SUB_CURRENT)
@@ -143,8 +143,7 @@
 vboxmouse_drv_16_DEFS := $(vboxmouse_drv_70_DEFS) NO_ANSIC
 vboxmouse_drv_16_INCS := \
-	$(VBOX_PATH_X11_XORG_1_6) \
 	$(VBOX_PATH_X11_ROOT)/inputproto-1.4.4 \
+	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_16_SOURCES = \
@@ -166,6 +165,5 @@
 	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
 	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.99-20090831 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.7.7 \
 	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18 \
 	$(PATH_SUB_CURRENT)
@@ -187,5 +185,4 @@
 	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.8.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
 	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18 \
 	$(PATH_SUB_CURRENT)
@@ -207,5 +204,4 @@
 	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.9.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
 	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18 \
 	$(PATH_SUB_CURRENT)
@@ -227,5 +223,4 @@
 	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.10.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
 	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18 \
 	$(PATH_SUB_CURRENT)
@@ -243,5 +238,4 @@
 	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.11.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
 	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18 \
 	$(PATH_SUB_CURRENT)
@@ -259,5 +253,4 @@
 	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.12.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
 	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18 \
 	$(PATH_SUB_CURRENT)
Index: trunk/src/VBox/Additions/x11/vboxvideo/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/x11/vboxvideo/Makefile.kmk	(revision 43274)
+++ trunk/src/VBox/Additions/x11/vboxvideo/Makefile.kmk	(revision 43275)
@@ -32,4 +32,17 @@
 vboxvideo_15_DEFS := \
 	$(vboxvideo_13_DEFS) VBOX_DRI NO_ANSIC PCIACCESS XSERVER_LIBPCIACCESS
+vboxvideo_13_INCS = \
+	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
+	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
+	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
+	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
+	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
+	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
+	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
+	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
+	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
+	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
+	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
+	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
 
 #
@@ -153,11 +166,6 @@
 vboxvideo_drv_13_DEFS := $(vboxvideo_13_DEFS) XORG_VERSION_CURRENT=100300000
 vboxvideo_drv_13_INCS = \
-	$(VBOX_PATH_X11_XORG_1_3) \
-	$(VBOX_PATH_X11_XORG_1_3)/X11 \
-	$(VBOX_PATH_X11_XORG_1_3)/xorg \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.3.0.0
 vboxvideo_drv_13_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_13_SOURCES = $(vboxvideo_drv_SOURCES) edid.c
@@ -172,11 +180,6 @@
 vboxvideo_drv_14_DEFS := $(vboxvideo_13_DEFS) XORG_VERSION_CURRENT=100400000
 vboxvideo_drv_14_INCS = \
-	$(VBOX_PATH_X11_XORG_1_4) \
-	$(VBOX_PATH_X11_XORG_1_4)/X11 \
-	$(VBOX_PATH_X11_XORG_1_4)/xorg \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.4.2
 vboxvideo_drv_14_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_14_SOURCES  = $(vboxvideo_drv_13_SOURCES)
@@ -194,10 +197,5 @@
 endif
 vboxvideo_drv_15_INCS = \
-	$(VBOX_PATH_X11_XORG_1_5) \
-	$(VBOX_PATH_X11_XORG_1_5)/X11 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
+	$(vboxvideo_13_INCS) \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.5.3
 vboxvideo_drv_15_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
@@ -217,12 +215,6 @@
 vboxvideo_drv_16_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=100600000
 vboxvideo_drv_16_INCS = \
-	$(VBOX_PATH_X11_XORG_1_6) \
-	$(VBOX_PATH_X11_XORG_1_6)/X11 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
+	$(vboxvideo_13_INCS) \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_16_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_16_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -236,20 +228,7 @@
 vboxvideo_drv_17_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_17_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=100699000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_17_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.99-20090831 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.7.7
 vboxvideo_drv_17_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_17_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -263,20 +242,7 @@
 vboxvideo_drv_18_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_18_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=100800000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_18_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.8.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.8.0
 vboxvideo_drv_18_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_18_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -290,20 +256,7 @@
 vboxvideo_drv_19_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_19_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=100900000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_19_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.9.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.9.0
 vboxvideo_drv_19_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_19_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -317,20 +270,7 @@
 vboxvideo_drv_110_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_110_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=101000000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_110_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.10.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.10.0
 vboxvideo_drv_110_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_110_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -344,20 +284,7 @@
 vboxvideo_drv_111_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_111_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=101100000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_111_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.11.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.11.0
 vboxvideo_drv_111_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_111_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -371,20 +298,7 @@
 vboxvideo_drv_112_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_112_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=101200000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_112_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.12.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.12.0
 vboxvideo_drv_112_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_112_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -394,24 +308,11 @@
 # vboxvideo_drv_113
 #
-#DLLS += vboxvideo_drv_113
+DLLS += vboxvideo_drv_113
 vboxvideo_drv_113_TEMPLATE = VBOXGUESTR3XORGMOD
 vboxvideo_drv_113_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_113_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=101300000
-## @todo replace $(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local
 vboxvideo_drv_113_INCS = \
-	$(VBOX_PATH_X11_ROOT)/fontsproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/glproto-1.4.10 \
-	$(VBOX_PATH_X11_ROOT)/mesa-7.2/include \
-	$(VBOX_PATH_X11_ROOT)/inputproto-1.9.99.902 \
-	$(VBOX_PATH_X11_ROOT)/libdrm-2.4.13 \
-	$(VBOX_PATH_X11_ROOT)/libpciaccess-0.10.8 \
-	$(VBOX_PATH_X11_ROOT)/pixman-0.16.0 \
-	$(VBOX_PATH_X11_ROOT)/randrproto-1.3.0 \
-	$(VBOX_PATH_X11_ROOT)/renderproto-0.11 \
-	$(VBOX_PATH_X11_ROOT)/xextproto-7.1.1 \
-	$(VBOX_PATH_X11_ROOT)/xf86driproto-2.1.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.13.0 \
-	$(VBOX_PATH_X11_ROOT)/xorg-server-1.6.0-local \
-	$(VBOX_PATH_X11_ROOT)/xproto-7.0.18
+	$(vboxvideo_13_INCS) \
+	$(VBOX_PATH_X11_ROOT)/xorg-server-1.13.0
 vboxvideo_drv_113_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_113_SOURCES := $(vboxvideo_drv_15_SOURCES)
@@ -533,11 +434,11 @@
 	$(QUIET)$(APPEND) -t "$@" "done"
 
-#     TESTING += $(vboxvideo_drv_113_0_OUTDIR)/tstvboxvideo113.run
-#     OTHERS += $(vboxvideo_drv_113_0_OUTDIR)/tstvboxvideo113.run
-#$$(vboxvideo_drv_113_0_OUTDIR)/tstvboxvideo113.run: $$(vboxvideo_drv_113_1_STAGE_TARGET)
-#	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
-#	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_HOST)  \
-#	    $(vboxvideo_drv_113_1_STAGE_TARGET) $(VBOXVIDEO_SRC_PATH)/undefined
-#	$(QUIET)$(APPEND) -t "$@" "done"
+     TESTING += $(vboxvideo_drv_113_0_OUTDIR)/tstvboxvideo113.run
+     OTHERS += $(vboxvideo_drv_113_0_OUTDIR)/tstvboxvideo113.run
+$$(vboxvideo_drv_113_0_OUTDIR)/tstvboxvideo113.run: $$(vboxvideo_drv_113_1_STAGE_TARGET)
+	$(QUIET)$(call MSG_L1,Checking for unresolved symbols in $<)
+	$(QUIET)/bin/sh $(PATH_ROOT)/src/bldprogs/checkUndefined.sh $(KBUILD_HOST)  \
+	    $(vboxvideo_drv_113_1_STAGE_TARGET) $(VBOXVIDEO_SRC_PATH)/undefined
+	$(QUIET)$(APPEND) -t "$@" "done"
 
     endif # ! VBOX_ONLY_SDK