Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 43257)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 43316)
@@ -910,18 +910,18 @@
     db   'PCI: Unsupported function AX=%04X BX=%04X called', 00ah, 000h
 
-section CONST2 progbits vstart=0xcc4 align=1 ; size=0x3fe class=DATA group=DGROUP
-_bios_cvs_version_string:                    ; 0xf0cc4 LB 0x16
-    db  'VirtualBox 4.2.0_RC4', 000h, 000h
-_bios_prefix_string:                         ; 0xf0cda LB 0x8
+section CONST2 progbits vstart=0xcc4 align=1 ; size=0x3fa class=DATA group=DGROUP
+_bios_cvs_version_string:                    ; 0xf0cc4 LB 0x12
+    db  'VirtualBox 4.2.0', 000h, 000h
+_bios_prefix_string:                         ; 0xf0cd6 LB 0x8
     db  'BIOS: ', 000h, 000h
-_isotag:                                     ; 0xf0ce2 LB 0x6
+_isotag:                                     ; 0xf0cde LB 0x6
     db  'CD001', 000h
-_eltorito:                                   ; 0xf0ce8 LB 0x18
+_eltorito:                                   ; 0xf0ce4 LB 0x18
     db  'EL TORITO SPECIFICATION', 000h
-_drivetypes:                                 ; 0xf0d00 LB 0x28
+_drivetypes:                                 ; 0xf0cfc LB 0x28
     db  046h, 06ch, 06fh, 070h, 070h, 079h, 000h, 000h, 000h, 000h, 048h, 061h, 072h, 064h, 020h, 044h
     db  069h, 073h, 06bh, 000h, 043h, 044h, 02dh, 052h, 04fh, 04dh, 000h, 000h, 000h, 000h, 04ch, 041h
     db  04eh, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-_scan_to_scanascii:                          ; 0xf0d28 LB 0x37a
+_scan_to_scanascii:                          ; 0xf0d24 LB 0x37a
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 01bh, 001h, 01bh, 001h, 01bh, 001h
     db  000h, 001h, 000h, 000h, 031h, 002h, 021h, 002h, 000h, 000h, 000h, 078h, 000h, 000h, 032h, 003h
@@ -980,9 +980,9 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 085h, 000h, 087h, 000h, 089h, 000h, 08bh, 000h, 000h
     db  000h, 086h, 000h, 088h, 000h, 08ah, 000h, 08ch, 000h, 000h
-_panic_msg_keyb_buffer_full:                 ; 0xf10a2 LB 0x20
+_panic_msg_keyb_buffer_full:                 ; 0xf109e LB 0x20
     db  '%s: keyboard input buffer full', 00ah, 000h
 
-  ; Padding 0x53e bytes at 0xf10c2
-  times 1342 db 0
+  ; Padding 0x542 bytes at 0xf10be
+  times 1346 db 0
 
 section _TEXT progbits vstart=0x1600 align=1 ; size=0x7735 class=CODE group=AUTO
@@ -1148,5 +1148,5 @@
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -2273,5 +2273,5 @@
     xor dx, dx                                ; 31 d2
     mov word [bp-01ah], di                    ; 89 7e e6
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -2907,5 +2907,5 @@
     cmp byte [bp+00eh], 002h                  ; 80 7e 0e 02
     jne short 0285ah                          ; 75 1f
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -3691,5 +3691,5 @@
     cmp AL, strict byte 048h                  ; 3c 48
     jbe short 02f58h                          ; 76 29
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -4329,5 +4329,5 @@
     mov ax, strict word 00006h                ; b8 06 00
     jmp near 02e83h                           ; e9 19 f9
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -4486,5 +4486,5 @@
     pop si                                    ; 5e
     retn                                      ; c3
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -4628,5 +4628,5 @@
     jnc short 03881h                          ; 73 10
     mov al, byte [bp+di-00819h]               ; 8a 83 e7 f7
-    cmp al, byte [di+00ce2h]                  ; 3a 85 e2 0c
+    cmp al, byte [di+00cdeh]                  ; 3a 85 de 0c
     je short 0386bh                           ; 74 f0
     mov ax, strict word 00005h                ; b8 05 00
@@ -4638,5 +4638,5 @@
     jnc short 0389bh                          ; 73 10
     mov al, byte [bp+di-00813h]               ; 8a 83 ed f7
-    cmp al, byte [di+00ce8h]                  ; 3a 85 e8 0c
+    cmp al, byte [di+00ce4h]                  ; 3a 85 e4 0c
     je short 03885h                           ; 74 f0
     mov ax, strict word 00006h                ; b8 06 00
@@ -4979,5 +4979,5 @@
     cmp ax, dx                                ; 39 d0
     je short 03c26h                           ; 74 29
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5194,5 +5194,5 @@
     test dl, dl                               ; 84 d2
     je near 03f0eh                            ; 0f 84 d0 00
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5284,5 +5284,5 @@
     mov word [bp+01ah], bx                    ; 89 5e 1a
     jmp short 03f12h                          ; eb e5
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5557,5 +5557,5 @@
     cmp byte [bp-004h], 000h                  ; 80 7e fc 00
     je near 04296h                            ; 0f 84 bf 00
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5834,5 +5834,5 @@
     or byte [bp+022h], 001h                   ; 80 4e 22 01
     jmp near 042a9h                           ; e9 91 fd
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5864,10 +5864,10 @@
     je short 0457ah                           ; 74 21
     mov dx, strict word 00001h                ; ba 01 00
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 018aeh                               ; e8 47 d3
     imul dx, dx, strict byte 0000ah           ; 6b d2 0a
-    add dx, 00d00h                            ; 81 c2 00 0d
+    add dx, 00cfch                            ; 81 c2 fc 0c
     push dx                                   ; 52
     push 00402h                               ; 68 02 04
@@ -5888,9 +5888,9 @@
     test al, al                               ; 84 c0
     je short 045aah                           ; 74 1b
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 018aeh                               ; e8 14 d3
-    push 00d14h                               ; 68 14 0d
+    push 00d10h                               ; 68 10 0d
     push 00416h                               ; 68 16 04
     push strict byte 00004h                   ; 6a 04
@@ -5900,25 +5900,25 @@
     test dl, dl                               ; 84 d2
     je short 045beh                           ; 74 10
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 018aeh                               ; e8 f5 d2
-    push 00d1eh                               ; 68 1e 0d
+    push 00d1ah                               ; 68 1a 0d
     jmp short 0459dh                          ; eb df
     test bl, 080h                             ; f6 c3 80
     je short 045d4h                           ; 74 11
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 018aeh                               ; e8 e0 d2
     push si                                   ; 56
-    push 00d0ah                               ; 68 0a 0d
+    push 00d06h                               ; 68 06 0d
     jmp short 045e3h                          ; eb 0f
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 018aeh                               ; e8 cf d2
     push si                                   ; 56
-    push 00d00h                               ; 68 00 0d
+    push 00cfch                               ; 68 fc 0c
     push 0042bh                               ; 68 2b 04
     push strict byte 00004h                   ; 6a 04
@@ -5945,5 +5945,5 @@
     mov bp, sp                                ; 89 e5
     mov dx, ax                                ; 89 c2
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6017,5 +6017,5 @@
     mov byte [bp-006h], al                    ; 88 46 fa
     mov byte [bp-008h], al                    ; 88 46 f8
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6578,5 +6578,5 @@
     test al, al                               ; 84 c0
     jne short 04bc6h                          ; 75 19
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6781,5 +6781,5 @@
     cmp byte [bp-006h], 058h                  ; 80 7e fa 58
     jbe short 04e01h                          ; 76 1e
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6796,6 +6796,6 @@
     movzx si, byte [bp-006h]                  ; 0f b6 76 fa
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    mov dl, byte [si+00d2eh]                  ; 8a 94 2e 0d
-    mov ax, word [si+00d2eh]                  ; 8b 84 2e 0d
+    mov dl, byte [si+00d2ah]                  ; 8a 94 2a 0d
+    mov ax, word [si+00d2ah]                  ; 8b 84 2a 0d
     jmp near 04ea4h                           ; e9 8c 00
     test bl, 004h                             ; f6 c3 04
@@ -6803,6 +6803,6 @@
     movzx si, byte [bp-006h]                  ; 0f b6 76 fa
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    mov dl, byte [si+00d2ch]                  ; 8a 94 2c 0d
-    mov ax, word [si+00d2ch]                  ; 8b 84 2c 0d
+    mov dl, byte [si+00d28h]                  ; 8a 94 28 0d
+    mov ax, word [si+00d28h]                  ; 8b 84 28 0d
     jmp near 04ea4h                           ; e9 75 00
     mov al, byte [bp-002h]                    ; 8a 46 fe
@@ -6823,13 +6823,13 @@
     movzx si, byte [bp-006h]                  ; 0f b6 76 fa
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    movzx ax, byte [si+00d30h]                ; 0f b6 84 30 0d
+    movzx ax, byte [si+00d2ch]                ; 0f b6 84 2c 0d
     movzx dx, bl                              ; 0f b6 d3
     test dx, ax                               ; 85 c2
     je short 04e6fh                           ; 74 0a
-    mov dl, byte [si+00d28h]                  ; 8a 94 28 0d
-    mov ax, word [si+00d28h]                  ; 8b 84 28 0d
+    mov dl, byte [si+00d24h]                  ; 8a 94 24 0d
+    mov ax, word [si+00d24h]                  ; 8b 84 24 0d
     jmp short 04e77h                          ; eb 08
-    mov dl, byte [si+00d2ah]                  ; 8a 94 2a 0d
-    mov ax, word [si+00d2ah]                  ; 8b 84 2a 0d
+    mov dl, byte [si+00d26h]                  ; 8a 94 26 0d
+    mov ax, word [si+00d26h]                  ; 8b 84 26 0d
     shr ax, 008h                              ; c1 e8 08
     mov byte [bp-006h], al                    ; 88 46 fa
@@ -6837,13 +6837,13 @@
     movzx si, byte [bp-006h]                  ; 0f b6 76 fa
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    movzx ax, byte [si+00d30h]                ; 0f b6 84 30 0d
+    movzx ax, byte [si+00d2ch]                ; 0f b6 84 2c 0d
     movzx dx, bl                              ; 0f b6 d3
     test dx, ax                               ; 85 c2
     je short 04e9ch                           ; 74 0a
-    mov dl, byte [si+00d2ah]                  ; 8a 94 2a 0d
-    mov ax, word [si+00d2ah]                  ; 8b 84 2a 0d
+    mov dl, byte [si+00d26h]                  ; 8a 94 26 0d
+    mov ax, word [si+00d26h]                  ; 8b 84 26 0d
     jmp short 04ea4h                          ; eb 08
-    mov dl, byte [si+00d28h]                  ; 8a 94 28 0d
-    mov ax, word [si+00d28h]                  ; 8b 84 28 0d
+    mov dl, byte [si+00d24h]                  ; 8a 94 24 0d
+    mov ax, word [si+00d24h]                  ; 8b 84 24 0d
     shr ax, 008h                              ; c1 e8 08
     mov byte [bp-006h], al                    ; 88 46 fa
@@ -6852,5 +6852,5 @@
     test dl, dl                               ; 84 d2
     jne short 04ecah                          ; 75 16
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7225,5 +7225,5 @@
     or ah, 080h                               ; 80 cc 80
     jmp near 050f6h                           ; e9 d5 fe
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7236,5 +7236,5 @@
     call 018e9h                               ; e8 ae c6
     add sp, strict byte 00006h                ; 83 c4 06
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7386,5 +7386,5 @@
     test ax, ax                               ; 85 c0
     jne short 053d0h                          ; 75 23
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7415,5 +7415,5 @@
     cmp ax, dx                                ; 39 d0
     jbe short 0542bh                          ; 76 2e
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7472,8 +7472,8 @@
     db  0c0h, 001h, 0c3h, 006h, 056h, 0ffh, 097h, 0fch, 0ffh, 089h, 0c2h, 08bh, 046h, 016h, 030h, 0c0h
     db  08eh, 046h, 0fch, 026h, 08bh, 05ch, 014h, 009h, 0c3h, 089h, 05eh, 016h, 084h, 0d2h, 00fh, 084h
-    db  015h, 0feh, 0bbh, 0dah, 00ch, 08ch, 0d9h, 0b8h, 004h, 000h, 0e8h, 088h, 0c3h, 00fh, 0b6h, 0c2h
+    db  015h, 0feh, 0bbh, 0d6h, 00ch, 08ch, 0d9h, 0b8h, 004h, 000h, 0e8h, 088h, 0c3h, 00fh, 0b6h, 0c2h
     db  050h, 08bh, 046h, 016h, 0c1h, 0e8h, 008h, 050h, 068h, 0ech, 005h, 068h, 0c7h, 006h, 06ah, 004h
     db  0e8h, 0adh, 0c3h, 083h, 0c4h, 00ah, 08bh, 046h, 016h, 030h, 0e4h, 080h, 0cch, 00ch, 0e9h, 051h
-    db  001h, 0bbh, 0dah, 00ch, 08ch, 0d9h, 0b8h, 004h, 000h, 0e8h, 059h, 0c3h, 068h, 0e8h, 006h, 06ah
+    db  001h, 0bbh, 0d6h, 00ch, 08ch, 0d9h, 0b8h, 004h, 000h, 0e8h, 059h, 0c3h, 068h, 0e8h, 006h, 06ah
     db  004h, 0e8h, 08ch, 0c3h, 083h, 0c4h, 004h, 0e9h, 0cdh, 0fdh, 00fh, 0b6h, 046h, 0feh, 06bh, 0c0h
     db  018h, 08eh, 046h, 0fch, 089h, 0f3h, 001h, 0c3h, 026h, 08bh, 07fh, 028h, 026h, 08bh, 04fh, 026h
@@ -7491,8 +7491,8 @@
     db  031h, 0d2h, 08bh, 05eh, 0f8h, 031h, 0c9h, 0e8h, 046h, 036h, 08bh, 05eh, 0fah, 031h, 0c9h, 0e8h
     db  03eh, 036h, 089h, 046h, 0f0h, 089h, 056h, 0f2h, 089h, 056h, 014h, 089h, 046h, 012h, 08bh, 046h
-    db  016h, 030h, 0e4h, 080h, 0cch, 003h, 089h, 046h, 016h, 0e9h, 0dfh, 0fch, 0bbh, 0dah, 00ch, 08ch
+    db  016h, 030h, 0e4h, 080h, 0cch, 003h, 089h, 046h, 016h, 0e9h, 0dfh, 0fch, 0bbh, 0d6h, 00ch, 08ch
     db  0d9h, 0b8h, 004h, 000h, 0e8h, 04eh, 0c2h, 08bh, 046h, 016h, 0c1h, 0e8h, 008h, 050h, 068h, 0ech
     db  005h, 068h, 002h, 007h, 06ah, 004h, 0e8h, 077h, 0c2h, 083h, 0c4h, 008h, 0e9h, 0b8h, 0fch, 0bbh
-    db  0dah, 00ch, 08ch, 0d9h, 0b8h, 004h, 000h, 0e8h, 02bh, 0c2h, 08bh, 046h, 016h, 0c1h, 0e8h, 008h
+    db  0d6h, 00ch, 08ch, 0d9h, 0b8h, 004h, 000h, 0e8h, 02bh, 0c2h, 08bh, 046h, 016h, 0c1h, 0e8h, 008h
     db  050h, 068h, 0ech, 005h, 068h, 035h, 007h, 0e9h, 032h, 0fdh, 08bh, 046h, 016h, 030h, 0e4h, 080h
     db  0cch, 001h, 089h, 046h, 016h, 08bh, 05eh, 016h, 0c1h, 0ebh, 008h, 030h, 0ffh, 0bah, 074h, 000h
@@ -7602,5 +7602,5 @@
     cmp dx, word [es:bx+032h]                 ; 26 3b 57 32
     jc short 0581ah                           ; 72 23
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7654,5 +7654,5 @@
     test dl, dl                               ; 84 d2
     je near 05b35h                            ; 0f 84 97 02
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7890,5 +7890,5 @@
     leave                                     ; c9
     retn                                      ; c3
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8218,5 +8218,5 @@
     mov word [bp+010h], ax                    ; 89 46 10
     jmp near 05e85h                           ; e9 2b 00
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8559,5 +8559,5 @@
     retf                                      ; cb
     jmp near 05e85h                           ; e9 ba fc
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8599,5 +8599,5 @@
     or byte [bp+01ch], 001h                   ; 80 4e 1c 01
     jmp near 05e85h                           ; e9 44 fc
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8887,5 +8887,5 @@
     pop si                                    ; 5e
     retn                                      ; c3
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -9205,5 +9205,5 @@
     je short 06856h                           ; 74 0e
     push 00884h                               ; 68 84 08
-    push 010a2h                               ; 68 a2 10
+    push 0109eh                               ; 68 9e 10
     push strict byte 00007h                   ; 6a 07
     call 018e9h                               ; e8 96 b0
@@ -9266,5 +9266,5 @@
     je short 068bfh                           ; 74 0e
     push 0088eh                               ; 68 8e 08
-    push 010a2h                               ; 68 a2 10
+    push 0109eh                               ; 68 9e 10
     push strict byte 00007h                   ; 6a 07
     call 018e9h                               ; e8 2d b0
@@ -10614,5 +10614,5 @@
     cmp bx, 00200h                            ; 81 fb 00 02
     je short 07574h                           ; 74 20
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -11651,5 +11651,5 @@
     cmp byte [bp+00eh], 002h                  ; 80 7e 0e 02
     jne short 07f97h                          ; 75 1f
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -11997,5 +11997,5 @@
     mov word [bp-016h], ax                    ; 89 46 ea
     mov dx, word [bp-01ah]                    ; 8b 56 e6
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -12469,5 +12469,5 @@
     or ah, 080h                               ; 80 cc 80
     jmp short 087c4h                          ; eb ea
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -12751,5 +12751,5 @@
     mov word [bp+018h], 00a00h                ; c7 46 18 00 0a
     jmp short 08ad2h                          ; eb 2d
-    mov bx, 00cdah                            ; bb da 0c
+    mov bx, 00cd6h                            ; bb d6 0c
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -15164,3 +15164,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0cbh
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0f5h
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.md5sum	(revision 43257)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.md5sum	(revision 43316)
@@ -1,1 +1,1 @@
-ffabb374e7f00d18e0561b87add8e573 *VBoxPcBios.rom
+57dac3e8f20bd1918af25a3b6b5e6cfb *VBoxPcBios.rom