Index: trunk/src/VBox/VMM/VMMR3/EMHM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/EMHM.cpp	(revision 43390)
+++ trunk/src/VBox/VMM/VMMR3/EMHM.cpp	(revision 43391)
@@ -64,5 +64,5 @@
 DECLINLINE(int) emR3ExecuteInstruction(PVM pVM, PVMCPU pVCpu, const char *pszPrefix, int rcGC = VINF_SUCCESS);
 static int emR3ExecuteIOInstruction(PVM pVM, PVMCPU pVCpu);
-static int emR3HwaccmForcedActions(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx);
+static int emR3HmForcedActions(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx);
 
 #define EMHANDLERC_WITH_HM
@@ -93,5 +93,5 @@
         ||  VMCPU_FF_ISPENDING(pVCpu, VMCPU_FF_HIGH_PRIORITY_PRE_RAW_MASK))
     {
-        rc = emR3HwaccmForcedActions(pVM, pVCpu, pCtx);
+        rc = emR3HmForcedActions(pVM, pVCpu, pCtx);
         if (rc != VINF_SUCCESS)
             return rc;
@@ -123,5 +123,5 @@
      */
     rc = emR3HighPriorityPostForcedActions(pVM, pVCpu, rc);
-    rc = emR3HwaccmHandleRC(pVM, pVCpu, pCtx, rc);
+    rc = emR3HmHandleRC(pVM, pVCpu, pCtx, rc);
     return rc;
 }
@@ -392,5 +392,5 @@
  * @param   pCtx        Pointer to the guest CPU context.
  */
-static int emR3HwaccmForcedActions(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx)
+static int emR3HmForcedActions(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx)
 {
     /*
@@ -499,5 +499,5 @@
             ||  VMCPU_FF_ISPENDING(pVCpu, VMCPU_FF_HIGH_PRIORITY_PRE_RAW_MASK))
         {
-            rc = emR3HwaccmForcedActions(pVM, pVCpu, pCtx);
+            rc = emR3HmForcedActions(pVM, pVCpu, pCtx);
             if (rc != VINF_SUCCESS)
                 break;
@@ -568,5 +568,5 @@
             break;
 
-        rc = emR3HwaccmHandleRC(pVM, pVCpu, pCtx, rc);
+        rc = emR3HmHandleRC(pVM, pVCpu, pCtx, rc);
         if (rc != VINF_SUCCESS)
             break;
Index: trunk/src/VBox/VMM/VMMR3/HM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 43390)
+++ trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 43391)
@@ -1294,6 +1294,6 @@
                 if (pVM->hm.s.vmx.fUsePreemptTimer)
                 {
-                    PCFGMNODE pCfgHwAccM = CFGMR3GetChild(CFGMR3GetRoot(pVM), "HM");
-                    int rc2 = CFGMR3QueryBoolDef(pCfgHwAccM, "UsePreemptTimer", &pVM->hm.s.vmx.fUsePreemptTimer, true);
+                    PCFGMNODE pCfgHm = CFGMR3GetChild(CFGMR3GetRoot(pVM), "HM");
+                    int rc2 = CFGMR3QueryBoolDef(pCfgHm, "UsePreemptTimer", &pVM->hm.s.vmx.fUsePreemptTimer, true);
                     AssertLogRelRC(rc2);
                 }
Index: trunk/src/VBox/VMM/VMMR3/VMMTests.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/VMMTests.cpp	(revision 43390)
+++ trunk/src/VBox/VMM/VMMR3/VMMTests.cpp	(revision 43391)
@@ -469,5 +469,5 @@
 
 /* execute the switch. */
-VMMR3DECL(int) VMMDoHwAccmTest(PVM pVM)
+VMMR3DECL(int) VMMDoHmTest(PVM pVM)
 {
     uint32_t i;
Index: trunk/src/VBox/VMM/include/EMHandleRCTmpl.h
===================================================================
--- trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 43390)
+++ trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 43391)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * EM - emR3[Raw|Hwaccm]HandleRC template.
+ * EM - emR3[Raw|Hm]HandleRC template.
  */
 
@@ -36,5 +36,5 @@
 int emR3RawHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc)
 #elif defined(EMHANDLERC_WITH_HM)
-int emR3HwaccmHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc)
+int emR3HmHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc)
 #endif
 {
@@ -336,5 +336,5 @@
 #ifdef EMHANDLERC_WITH_HM
         /*
-         * Up a level, after HwAccM have done some release logging.
+         * Up a level, after Hm have done some release logging.
          */
         case VERR_VMX_INVALID_VMCS_FIELD:
Index: trunk/src/VBox/VMM/include/EMInternal.h
===================================================================
--- trunk/src/VBox/VMM/include/EMInternal.h	(revision 43390)
+++ trunk/src/VBox/VMM/include/EMInternal.h	(revision 43391)
@@ -445,5 +445,5 @@
 int     emR3RawExecute(PVM pVM, PVMCPU pVCpu, bool *pfFFDone);
 int     emR3RawHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc);
-int     emR3HwaccmHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc);
+int     emR3HmHandleRC(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx, int rc);
 EMSTATE emR3Reschedule(PVM pVM, PVMCPU pVCpu, PCPUMCTX pCtx);
 int     emR3ForcedActions(PVM pVM, PVMCPU pVCpu, int rc);
Index: trunk/src/VBox/VMM/testcase/tstVMM-HM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMM-HM.cpp	(revision 43390)
+++ trunk/src/VBox/VMM/testcase/tstVMM-HM.cpp	(revision 43391)
@@ -34,7 +34,7 @@
 *   Defined Constants And Macros                                               *
 *******************************************************************************/
-#define TESTCASE    "tstVMM-HwAccm"
+#define TESTCASE    "tstVMM-Hm"
 
-VMMR3DECL(int) VMMDoHwAccmTest(PVM pVM);
+VMMR3DECL(int) VMMDoHmTest(PVM pVM);
 
 
@@ -76,5 +76,5 @@
              TESTCASE ": causes kernel panics on linux regardless of what\n"
              TESTCASE ": RTAssertDoBreakpoint returns. Only checked AMD-V on linux.\n");
-    /** @todo Make tstVMM-HwAccm to cause kernel panics. */
+    /** @todo Make tstVMM-Hm to cause kernel panics. */
     return 1;
 
@@ -91,5 +91,5 @@
          */
         RTPrintf(TESTCASE ": Testing...\n");
-        rc = VMR3ReqCallWait(pVM, VMCPUID_ANY, (PFNRT)VMMDoHwAccmTest, 1, pVM);
+        rc = VMR3ReqCallWait(pVM, VMCPUID_ANY, (PFNRT)VMMDoHmTest, 1, pVM);
         AssertRC(rc);
 